unit phIPAddress;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, Commctrl, stdCtrls;

const
	ICC_INTERNET_CLASSES	 = $00000800;

	IPN_FIRST              = (0 - 860);       // internet address
	IPN_LAST               = (0 - 879);       // internet address

	///////////////////////////////////////////////
///    IP Address edit control

// Messages sent to IPAddress controls

	IPM_CLEARADDRESS  = (WM_USER+100); // no parameters
	IPM_SETADDRESS    = (WM_USER+101); // lparam = TCP/IP address
	IPM_GETADDRESS    = (WM_USER+102); // lresult = # of non black fields.  lparam = LPDWORD for TCP/IP address
	IPM_SETRANGE      = (WM_USER+103); // wparam = field, lparam = range
	IPM_SETFOCUS      = (WM_USER+104); // wparam = field
	IPM_ISBLANK       = (WM_USER+105); // no parameters


	WC_IPADDRESS           = 'SysIPAddress32';


	IPN_FIELDCHANGED               = (IPN_FIRST - 0);


// The following is a useful macro for passing the range values in the
// IPM_SETRANGE message.

//#define MAKEIPRANGE(low, high)    ((LPARAM)(WORD)(((BYTE)(high) << 8) + (BYTE)(low)))
function MakeIPRange(Low, High: Byte): Word;

// And this is a useful macro for making the IP Address to be passed
// as a LPARAM.

//#define MAKEIPADDRESS(b1,b2,b3,b4)  ((LPARAM)(((DWORD)(b1)<<24)+((DWORD)(b2)<<16)+((DWORD)(b3)<<8)+((DWORD)(b4))))
function MakeIPAddress(b1, b2, b3, b4: Byte): DWord;

// Get individual number
//#define FIRST_IPADDRESS(x)  ((x>>24) & 0xff)
//#define SECOND_IPADDRESS(x) ((x>>16) & 0xff)
//#define THIRD_IPADDRESS(x)  ((x>>8) & 0xff)
//#define FOURTH_IPADDRESS(x) (x & 0xff)
function First_IPAddress(X: DWord): Byte;
function Second_IPAddress(X: DWord): Byte;
function Third_IPAddress(X: DWord): Byte;
function Fourth_IPAddress(X: DWord): Byte;

//typedef struct tagNMIPADDRESS
	//{
  //      NMHDR hdr;
  //      int iField;
  //      int iValue;
	//} NMIPADDRESS, *LPNMIPADDRESS;
Type
	PTNMIPADDRESS = ^TNMIPADDRESS;
  TNMIPADDRESS = record
  	hdr: TNMHDR;
    Field: integer;
  	Value: integer;
  end;

//#endif // NOIPADDRESS



type
	TFieldRange = record
  	LowRange: Byte;
    HighRange: Byte;
  end;

	function FieldRange(Low, High: Byte): TFieldRange;

type
	TphFieldChange = procedure(Sender: TObject; Field: Integer;
  	Value: Integer) of Object;

  TphIPAddress = class(TWinControl)
  private
    { Private declarations }
   // FFont: TFont;
    FCreating: Boolean;
    FValue: LongInt;
    FFieldRanges: array [0..3] of TFieldRange;
    FOnChange: TNotifyEvent;
    FOnEnter: TNotifyEvent;
    FOnExit: TNotifyEvent;
    FOnFieldChange: TphFieldChange;
    FFirstIPAddress: Byte;
    FSecondIPAddress: Byte;
    FThirdIPAddress: Byte;
    FFourthIPAddress: Byte;
    function GetFirstIPAddress: Byte;
    procedure SetFirstIPAddress(Value: Byte);
    function GetSecondIPAddress: Byte;
    procedure SetSecondIPAddress(Value: Byte);
    function GetThirdIPAddress: Byte;
    procedure SetThirdIPAddress(Value: Byte);
    function GetFourthIPAddress: Byte;
    procedure SetFourthIPAddress(Value: Byte);
    function GetIPAddress(Field: integer): Byte;
    procedure SetIPAddress;
    function GetBlank: Boolean;
    function GetFieldRanges(Field: Integer): TFieldRange;
    procedure SetFieldRanges(Field:integer; Value: TFieldRange);
    //procedure SetValue(Value: Cardinal);
    function GetValue: LongInt;
    procedure WMNotifyFormat(var Message: TMessage); message WM_NOTIFYFORMAT;
   	procedure CNNotify(var Message: TWMNotify); message CN_NOTIFY;
    procedure CNCommand(var Message: TWMCommand); message CN_COMMAND;
    procedure WMSetFont(var Message: TWMSetFont); message WM_SETFONT;
  protected
    { Protected declarations }
    procedure CreateParams(var Params: TCreateParams); override;
    procedure CreateWnd; override;
    procedure DestroyWnd; override;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Clear;
    procedure SetAllRanges(Range: TFieldRange);
  published
    { Published declarations }
    property Blank: Boolean
    	read GetBlank;
    property FirstRange: TFieldRange index 0
    	read GetFieldRanges
      write SetFieldRanges;
    property SecondRange: TFieldRange index 1
    	read GetFieldRanges
      write SetFieldRanges;
    property ThirdRange: TFieldRange index 2
    	read GetFieldRanges
      write SetFieldRanges;
    property FourthRange: TFieldRange index 3
    	read GetFieldRanges
      write SetFieldRanges;
    property Field1: Byte
    	read GetFirstIPAddress
      write SetFirstIPAddress;
    property Field2: Byte
    	read GetSecondIPAddress
      write SetSecondIPAddress;
    property Field3: Byte
    	read GetThirdIPAddress
      write SetThirdIPAddress;
    property Field4: Byte
    	read GetFourthIPAddress
      write SetFourthIPAddress;


    property OnChange: TNotifyEvent
    	read FOnChange
      write FOnChange;
    property OnEnter: TNotifyEvent
    	read FOnEnter
      write FOnEnter;
    property OnExit: TNotifyEvent
    	read FOnExit
      write FOnExit;
    property OnFieldChange: TphFieldChange
    	read FOnFieldChange
      write FOnFieldChange;
    property Value: LongInt
    	read GetValue;
      //write SetValue;

    //property Font;
    property Enabled;
   	property TabOrder;
    property TabStop;
    property ParentShowHint;
    property ShowHint;
    property Hint;
    property PopupMenu;
    property Visible;
  end;

procedure Register;

implementation

function MakeIPRange(Low, High: Byte): Word;
begin
	Result:= (High shl $8) + Low;
end;

function MakeIPAddress(b1, b2, b3, b4: Byte): DWord;
begin
	Result:= (b1 shl 24) + (b2 shl 16) + (b3 shl 8) + (b4);
end;

function First_IPAddress(X: DWord): Byte;
begin
	Result:= (X shr 24) and $FF;
end;

function Second_IPAddress(X: DWord): Byte;
begin
	Result:= (X shr 16) and $FF;
end;

function Third_IPAddress(X: DWord): Byte;
begin
	Result:= (X shr 8) and $FF;
end;

function Fourth_IPAddress(X: DWord): Byte;
begin
	Result:= (X and $FF);
end;

function FieldRange(Low, High: Byte): TFieldRange;
begin
	Result.LowRange:= Low;
  Result.HighRange:= High;
end;

//******************* TphIPAddress ***************************//
//
//
//********************************************************//

constructor TphIPAddress.Create(AOwner: TComponent);
var
	i: integer;
begin
	CheckCommonControl(ICC_INTERNET_CLASSES or ICC_BAR_CLASSES);
	inherited Create(AOwner);
  //ControlStyle := [csClickEvents, csCaptureMouse];

  For i:= 0 to 3 do
  begin
  	FFieldRanges[i].LowRange:= 0;
    FFieldRanges[i].HighRange:= 255;
  end;

  FFirstIPAddress:= 0;
  FSecondIPAddress:= 0;
  FThirdIPAddress:= 0;
  FFourthIPAddress:= 0;

  FValue:= MakeIPAddress(FFirstIPAddress, FSecondIPAddress,
  	FThirdIPAddress, FFourthIPAddress);

  Height:= 25;
  Width:= 151;

  TabSTop:= True;
end;

procedure TphIPAddress.DestroyWnd;
begin

	inherited DestroyWnd
end;

destructor TphIPAddress.Destroy;
begin

  
	inherited Destroy;
end;

procedure TphIPAddress.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  CreateSubClass(Params, WC_IPADDRESS);
  with Params do
  begin                             
    //WindowClass.style := WindowClass.style and not (CS_HREDRAW or
    //	CS_VREDRAW);
  end;
end;

procedure TphIPAddress.CreateWnd;
begin
  FCreating := True;
  try
    inherited CreateWnd;
    //set the IPAddress to 0.0.0.0
    SetIPAddress;
  finally
    FCreating := False;
  end;
end;

function TphIPAddress.GetBlank: Boolean;
begin
	Result:= Boolean(perform(IPM_ISBLANK, 0, 0));
end;

procedure TphIPAddress.Clear;
begin
	perform(IPM_CLEARADDRESS, 0, 0);
end;

function TphIPAddress.GetFieldRanges(Field: Integer): TFieldRange;
begin
		Result:= FFieldRanges[Field];
end;

procedure TphIPAddress.SetFieldRanges(Field:integer; Value: TFieldRange);
begin
	if Value.LowRange > Value.HighRange then
  	exit;

	if (FFieldRanges[Field].LowRange <> Value.LowRange) or
  	(FFieldRanges[Field].HighRange <> Value.HighRange) then
  begin
    FFieldRanges[Field]:= Value;
  	perform(IPM_SETRANGE, Field,
  	 	MakeIPRange(Value.LowRange, Value.HighRange));

  end;
end;

procedure TphIPAddress.SetAllRanges(Range: TFieldRange);
var
	i: integer;
begin
	for i:= 0 to 3 do
  begin
		SetFieldRanges(i, Range);
  end;
end;

function TphIPAddress.GetFirstIPAddress: Byte;
begin
	Result:= GetIPAddress(0);
end;

procedure TphIPAddress.SetFirstIPAddress(Value: Byte);
begin
	if (FFirstIPAddress <> Value) or (Value <= $FF) then
  begin
  	FFirstIPAddress:= Value;
		SetIPAddress;
  end;
end;

function TphIPAddress.GetSecondIPAddress: Byte;
begin
	Result:= GetIPAddress(1);
end;

procedure TphIPAddress.SetSecondIPAddress(Value: Byte);
begin
	if (FSecondIPAddress <> Value) or (Value <= $FF) then
  begin
  	FSecondIPAddress:= Value;
		SetIPAddress;
  end;
end;

function TphIPAddress.GetThirdIPAddress: Byte;
begin
	Result:= GetIPAddress(2);
end;

procedure TphIPAddress.SetThirdIPAddress(Value: Byte);
begin
	if (FThirdIPAddress <> Value) or (Value <= $FF) then
  begin
  	FThirdIPAddress:= Value;
		SetIPAddress;
  end;
end;

function TphIPAddress.GetFourthIPAddress: Byte;
begin
	Result:= GetIPAddress(3);
end;

procedure TphIPAddress.SetFourthIPAddress(Value: Byte);
begin
	if (FFourthIPAddress <> Value) or (Value <= $FF) then
  begin
  	FFourthIPAddress:= Value;
		SetIPAddress;
  end;
end;

function TphIPAddress.GetIPAddress(Field: integer): Byte;
begin
	result:= 0;
	case Field of
  	0: Result:= FFirstIPAddress;
    1: Result:= FSecondIPAddress;
    2: Result:= FThirdIPAddress;
    3: Result:= FFourthIPAddress;
  end;

end;

procedure TphIPAddress.SetIPAddress;
begin
  Perform(IPM_SETADDRESS, 0,
    	MAKEIPADDRESS(FFirstIPAddress, FSecondIPAddress,
      	FThirdIPAddress, FFourthIPAddress));

  FValue:= MakeIPAddress(FFirstIPAddress, FSecondIPAddress,
  	FThirdIPAddress, FFourthIPAddress);
end;

{
procedure TphIPAddress.SetValue(Value: Cardinal);
begin
	if (FValue <> Value) then
  begin

    FFirstIPAddress:= First_IPAddress(Value);
    FSecondIPAddress:= Second_IPAddress(Value);
    FThirdIPAddress:= Third_IPAddress(Value);
    FFourthIPAddress:= Fourth_IPAddress(Value);

    SetIPAddress;
  end;
end;
}

function TphIPAddress.GetValue: LongInt;
var
	buffer: LongInt;
begin     
  buffer:= 0;
	perform(IPM_GETADDRESS, 0, LongInt(@Buffer));
  Result:= Buffer;
end;

procedure TphIPAddress.WMSetFont(var Message: TWMSetFont);
begin
	//Do not inherited this message
  //
	//inherited;
end;  

procedure TphIPAddress.WMNotifyFormat(var Message: TMessage);
begin
  with Message do
    Result := DefWindowProc(Handle, Msg, WParam, LParam);
end;


procedure TphIPAddress.CNNotify(var Message: TWMNotify);
var
	pNMIPAddress: PTNMIPADDRESS;
begin
	with (Message.NMHdr)^ do
  begin
  	case Code of  
  		IPN_FIELDCHANGED:
    	begin
       	pNMIPAddress:= PTNMIPADDRESS(Message.NMHdr);
        case pNMIPAddress^.Field of
        	0: FFirstIPAddress := pNMIPAddress^.Value;
          1: FSecondIPAddress := pNMIPAddress^.Value;
          2: FThirdIPAddress := pNMIPAddress^.Value;
          3: FFourthIPAddress := pNMIPAddress^.Value;
        end;
        if Assigned(FOnFieldChange) then FOnFieldChange(self,
        	pNMIPAddress^.Field, pNMIPAddress^.Value);

    	end;
    end;
  end;
end;

procedure TphIPAddress.CNCommand(var Message: TWMCommand);
begin
	case Message.NotifyCode of

  	EN_CHANGE:
    begin
    	if not FCreating then
      begin
      	if Assigned(FOnChange) then FOnChange(self);
      end;
    end;
    EN_KILLFOCUS:
    	if Assigned(FOnExit) then FOnExit(self);

    EN_SETFOCUS:
    	if Assigned(FOnEnter) then FOnEnter(self);

  end;
end;


procedure Register;
begin
  RegisterComponents('phWare', [TphIPAddress]);
end;

end.
